class ToolBoxError(Exception):
    """ 
    Parent Toolbox exception. (to be defined)
    """
    pass


class ToolBoxPathError(ToolBoxError):
    def __init__(self, message = "", path = ""):
        self.path = path
        self.message = f'Invalid path: {path}. ' + message


class ToolBoxTypeError(ToolBoxError):
    def __init__(self, msg = "", dtype = ''):
        self.dtype = dtype
        self.message = "Unknown data type: " + dtype + " \n" + msg

        
class ToolBoxValueError(ToolBoxError):
    def __init__(self, msg = "", val = None):
        self.value = val
        self.message = msg + " unknown value: " + str(val)


class ToolBoxFileError(ToolBoxError):
    def __init__(self, msg = "", val = ''):
        self.value = val
        self.message = f"file: {val}, {msg}"